local sprite = require 'sprite'
local introh = require 'introhandler'
local menu = require 'menu'
local settings = require 'settings'
local themap = require 'map'

love.window.setFullscreen(true, "desktop")

function love.load()
    menu:load()
    sprite:load()
    introh:load()
    
end

function love.update(dt)
    sprite:update(dt)
    introh:update(dt)
    menu:update(dt)
end

function love.draw()
    introh:draw()
    menu:draw()
end

function love.keypressed(key)
    menu:keypressed(key)
end

